##########################################################################
#
#  THIS FILE IS GENERATED FROM TEMPLATE. DON'T MODIFY IT
#
#  uniee_values.py
#
#  Created on: Jan 14, 2022
#      Author: Miroslav Ondra <ondra@faster.cz>
# 


class Product:
	def __init__(self, id, name, **kwargs):
		self.id = id
		self.name = name
		self.vars = kwargs

class Board:
	def __init__(self, id, name, slots, **kwargs):
		self.id = id
		self.name = name
		self.slots = slots
		self.vars = kwargs

class Slot:
	def __init__(self, slot, **kwargs):
		self.slot = slot
		self.vars = kwargs

products = {
  '1': Product(1, 'UNIPI10'),
  '257': Product(257, 'UNIPI11', has_rtc='1' ),
  '4353': Product(4353, 'UNIPI1L'),
  '2': Product(2, 'G100'),
  '258': Product(258, 'G110'),
  '271': Product(271, 'IRISx1'),
  '527': Product(527, 'IRISx2'),
  '783': Product(783, 'IRISx5'),
  '1039': Product(1039, 'IRISx7'),
  '1295': Product(1295, 'IRISx21'),
  '259': Product(259, 'S103'),
  '515': Product(515, 'M103'),
  '771': Product(771, 'M203'),
  '1027': Product(1027, 'M303'),
  '1283': Product(1283, 'M523'),
  '1539': Product(1539, 'L203'),
  '1795': Product(1795, 'L403'),
  '2051': Product(2051, 'L523'),
  '2307': Product(2307, 'L533'),
  '2563': Product(2563, 'S103_G'),
  '2819': Product(2819, 'M403'),
  '3075': Product(3075, 'M503'),
  '3331': Product(3331, 'M603'),
  '3587': Product(3587, 'L303'),
  '3843': Product(3843, 'L503'),
  '4099': Product(4099, 'L513'),
  '4355': Product(4355, 'S103_E'),
  '4611': Product(4611, 'S103_I'),
  '263': Product(263, 'S107'),
  '519': Product(519, 'S207'),
  '775': Product(775, 'M207'),
  '1031': Product(1031, 'M527'),
  '1287': Product(1287, 'L207'),
  '1543': Product(1543, 'L527'),
  '1799': Product(1799, 'S117'),
  '2055': Product(2055, 'M267'),
  '2311': Product(2311, 'M567'),
  '2567': Product(2567, 'S167'),
  '2823': Product(2823, 'S227'),
  '272': Product(272, 'ACHE1'),
  '262': Product(262, 'AKUSO1'),
}

boards = {
  '1': Board(1, 'G_1001_1', None),
  '2': Board(2, 'G_1002_1', None),
  '3': Board(3, 'IM_SPR485SD_1', None),
  '4': Board(4, 'B_1000_1', None),
  '5': Board(5, 'B_1000_2', None),
  '6': Board(6, 'B_1000_3', None),
  '7': Board(7, 'N_1000_1', None),
  '8': Board(8, 'N_1001_1', None),
  '100': Board(100, 'IC_DiS4_0', None),
  '101': Board(101, 'IC_LoRaNode_1', None),
  '103': Board(103, 'IC_Light1P80_1', None),
  '104': Board(104, 'IC_AiF2Ao1_1', None),
  '105': Board(105, 'IC_DiS2Do2_1', None),
  '106': Board(106, 'IC_R485R485422_1', None),
  '107': Board(107, 'IC_AoU4_1', None),
  '108': Board(108, 'ID_AiUC8_1', None),
  '109': Board(109, 'ID_AiRTD8_1', None),
  '110': Board(110, 'ID_DiS8_1', None),
  '111': Board(111, 'ID_Do8_1', None),
  '112': Board(112, 'IC_CANFD_1', None),
  '113': Board(113, 'IC_Eth100_1', None),
  '114': Board(114, 'IC_R232_1', None),
  '115': Board(115, 'ID_SATA_1', None),
  '116': Board(116, 'ID_LTE_1', None),
  '117': Board(117, 'IC_GPS_1', None),
  '118': Board(118, 'IC_AccGyro_1', None),
  '119': Board(119, 'IC_Di1Ro2_1', None),
  '120': Board(120, 'ID_DiS16_1', None),
  '121': Board(121, 'ID_Do16_1', None),
  '122': Board(122, 'ID_R232x4_1', None),
  '123': Board(123, 'ID_AiUC8_2', None),
  '124': Board(124, 'IC_DiS4_1', None),
  '125': Board(125, 'IC_Ai2Ao1_1', None),
  '126': Board(126, 'ID_Em3f_1', None),
  '127': Board(127, 'IC_LoRaNode_2', None),
  '128': Board(128, 'IC_Zigbee_1', None),
  '1000': Board(1000, 'IC_IQRF_1', None),
  '1001': Board(1001, 'ID_Eth100Di1WiFi_1', None),
  '2000': Board(2000, 'CD_MACHZLM_1', None),
  '2001': Board(2001, 'CD_PACHGL420_1', None),
}

# Family names
family = {
  '1': 'UNIPI1',
  '2': 'G1XX',
  '3': 'NEURON',
  '5': 'AXON',
  '6': 'CM40',
  '7': 'PATRON',
  '15': 'IRIS',
  '16': 'OEM',
}

def unipi_product_info(product_id, version=None):
	''' return product_info or none '''
	return products.get(str(product_id), None)

def unipi_product_info_by_name(product_name, version=None):
	''' return product_info or none '''
	for k,v in products.items():
		if v.name.lower() == product_name.lower(): 
			return v
	short_name = product_name.lower()
	compare_len = len(short_name) - 1;
	while compare_len > 3:
		for k,v in products.items():
			if v.name.lower()[:compare_len] == short_name[:compare_len]: 
				return v
		compare_len -= 1

	return None

def unipi_board_info(board_id, slot=None, version=None):
	''' return board_info or None '''
	board_info = boards.get(str(board_id), None)
	if slot == None or board_info == None:
		return board_info
	if board_info.slots is None:
		return None
	return board_info.slots.get(str(slot), None)


def unipi_family_name(product_id):
	''' return family name or none '''
	return family.get(str(product_id & 0xff), None)
